


        LIST    p=16F84

        ORG 0
    CALL GO
CYCLE
   BCF ABORT,7
   BCF PORT_B,REDLED
   BCF PORT_B,GREENLED
   CALL SELECTINIT

WAITHERE CLRWDT
    BTFSC PORT_B,SEL
    GOTO WAITHERE

    MOVLW 0FFH
    MOVWF XODE       ;CODE=0
    CALL SELECT_MENU

    MOVLW 0A9H       ;2ND LINE
    CALL COMMAND

    MOVLW '2'
    CALL WRITE
    MOVLW '4'
    CALL WRITE
    MOVLW '0'
    CALL WRITE
    MOVLW '0'
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ''
    CALL WRITE

    CALL SELECT_MENU

    MOVLW 0A9H       ;2ND LINE
    CALL COMMAND

    MOVLW '4'
    CALL WRITE
    MOVLW '8'
    CALL WRITE
    MOVLW '0'
    CALL WRITE
    MOVLW '0'
    CALL WRITE

   CALL  SELECT_MENU

    MOVLW 0A9H       ;2ND LINE
    CALL COMMAND

    MOVLW '9'
    CALL WRITE
    MOVLW '6'
    CALL WRITE
    MOVLW '0'
    CALL WRITE
    MOVLW '0'
    CALL WRITE

   CALL  SELECT_MENU

    MOVLW 0A9H       ;2ND LINE
    CALL COMMAND

    MOVLW '1'
    CALL WRITE
    MOVLW '9'
    CALL WRITE
    MOVLW '2'
    CALL WRITE
    MOVLW '0'
    CALL WRITE
    MOVLW '0'
    CALL WRITE

    CALL  SELECT_MENU
    MOVLW 0A9H       ;2ND LINE
    CALL COMMAND
    MOVLW '3'
    CALL WRITE
    MOVLW '8'
    CALL WRITE
    MOVLW '4'
    CALL WRITE
    MOVLW '0'
    CALL WRITE
    MOVLW '0'
    CALL WRITE

   ;CALL  SELECT_MENU
   ;MOVLW 0A9H       ;2ND LINE
   ;CALL COMMAND
   ;MOVLW '5'
   ;CALL WRITE
   ;MOVLW '7'
   ;CALL WRITE
   ;MOVLW '6'
   ;CALL WRITE
   ;MOVLW '0'
   ;CALL WRITE
   ;MOVLW '0'
   ;CALL WRITE

   CALL  SELECT_MENU
    GOTO CYCLE

SELECT_MENU
MENU CLRWDT
    CALL DELAY_DATA
    BTFSS PORT_B,ENTER
    GOTO RELOAD                   ;  GOTO SETBAUD RATE
    BTFSC PORT_B,SEL
    GOTO MENU
    INCF XODE
SEL_DEBOUNCE CALL DELAY_DATA
    CLRWDT
    BTFSS PORT_B,SEL
    GOTO SEL_DEBOUNCE
    RETLW 0


RELOAD
   MOVF XODE,0
   CALL BAUD
   MOVWF CELL1

   MOVF XODE,0
   CALL BAUD15
   MOVWF CELL15
   GOTO RELOAD_A

BAUD
   ADDWF PC
   RETLW .138  ;2400 BAUD
   RETLW .68   ;4800 BAUD
   RETLW .34   ;9600 BAUD
   RETLW .14   ;19200 BAUD
   RETLW .5    ;38400 BAUD      ;5

BAUD15
   ADDWF PC
   RETLW .180  ;2400 BAUD
   RETLW .90   ;4800 BAUD
   RETLW .45   ;9600 BAUD
   RETLW .22   ;19200 BAUD
   RETLW .7   ;38400 BAUD     ;8


RELOAD_A
    CALL DELAY_DATA
    BTFSC PORT_B,ENTER
    GOTO RELOAD_A
    CALL CLEAR
    MOVLW 8     ;8 CHARACTERS
    MOVWF COUNTER

    MOVLW 01BH    ;INITIALISE INDEX
    MOVWF FSR

NEXT
    CALL RECEIVE_DATA
    BTFSC ABORT,7
    GOTO Z
    BCF DATABYTE,7   ;.......................
    MOVF DATABYTE,0
    MOVWF INDEX
    INCF FSR

    DECFSZ COUNTER,1
    GOTO NEXT



    ;READ MEMORY AND DISPLAY

Z
CYCLE_A
    MOVLW '1'
    MOVWF XODE
    MOVLW 8     ;8 CHARACTERS
    MOVWF COUNTER

    MOVLW 01BH    ;INITIALISE INDEX
    MOVWF FSR

NEXT_BYTE
    CALL POSITION

    MOVLW 080H   ;1ST DISPLAY ADDRESS
    CALL COMMAND

    MOVLW 8       ;DISPLAY OFF
    CALL COMMAND

    MOVF INDEX,0

;TEST FOR XONXOFF HANDSHAKE  GREEN LED = XON RED LED = RED LED

    MOVWF BUFFER  ;SAVE
    XORLW 011H          ;XON
    BTFSS STATUS,2
    GOTO A4
    BCF PORT_B,REDLED
    BSF PORT_B,GREENLED
A4
    MOVF BUFFER,0
    XORLW 013H          ;XOFF
    BTFSS STATUS,2
    GOTO A3
    BSF PORT_B,REDLED
    BCF PORT_B,GREENLED

A3
    MOVF BUFFER,0
    MOVWF A_N
    CALL WRITE

    CALL ASCII_HEX
    MOVLW 0CH     ;DISPLAY ON
    CALL COMMAND

    INCF FSR
A1  CLRWDT
    CALL DELAY_DATA
    BTFSS PORT_B,SEL
    GOTO CYCLE
    BTFSC PORT_B,ENTER
    GOTO A1
A2  CLRWDT
    BTFSS PORT_B,ENTER
    GOTO A2


    DECFSZ COUNTER,1
    GOTO NEXT_BYTE
    GOTO CYCLE_A


COMMAND
    MOVWF LCDDATA
    SWAPF LCDDATA,0    ;MSNIBBLE
    MOVWF PORT_A
    BCF PORT_B,RS
    BSF PORT_B,E
    CALL LDELAY
    BCF PORT_B,E

    MOVF LCDDATA,0    ;LSNIBBLE
    MOVWF PORT_A
    BCF PORT_B,RS
    BSF PORT_B,E
    CALL LDELAY
    BCF PORT_B,E

    RETLW 0

WRITE
    MOVWF A_N
    SWAPF A_N,0
    MOVWF PORT_A
    BSF PORT_B,RS
    BSF  PORT_B,E
    CALL DELAY_DATA
    BCF PORT_B,E

    MOVF A_N,0
    MOVWF PORT_A
    BSF PORT_B,RS
    BSF  PORT_B,E
    CALL DELAY_DATA
    BCF PORT_B,E

    RETLW 0

ASCII_HEX

    MOVLW 0A9H   ;2ND DISPLAY ADDRESS
    CALL COMMAND
    BCF A_N,7
    MOVF A_N,0
    MOVWF ASCII  ;SAVE ASCII
    SWAPF A_N,1
    MOVLW 0FH
    ANDWF A_N,0
    CALL BINARY
    MOVWF A_N
    CALL WRITE

    MOVLW 0FH
    ANDWF ASCII,0
    CALL BINARY
    MOVWF A_N
    CALL WRITE

    MOVLW 'h'
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    BTFSS BUFFER_2,7
    GOTO RXDTXD
    MOVLW 'T'
    CALL WRITE
    MOVLW 'x'
    CALL WRITE
    RETLW 0
                      ;rx tx message...................
RXDTXD
    MOVLW 'R'
    CALL WRITE
    MOVLW 'x'
    CALL WRITE
    RETLW 0

BINARY
    ADDWF PC
    RETLW '0'
    RETLW '1'
    RETLW '2'
    RETLW '3'
    RETLW '4'
    RETLW '5'
    RETLW '6'
    RETLW '7'
    RETLW '8'
    RETLW '9'
    RETLW 'A'
    RETLW 'B'
    RETLW 'C'
    RETLW 'D'
    RETLW 'E'
    RETLW 'F'

DELAY1ST
    MOVF CELL15,0
    MOVWF DLYCNT
REDA DECFSZ DLYCNT,1
    GOTO REDA
    CLRWDT
    RETLW 0

DELAY
    MOVF CELL1,0
    MOVWF DLYCNT
REDO DECFSZ DLYCNT,1
    GOTO REDO
    CLRWDT
    RETLW 0

RECEIVE_DATA
START_BIT
    CLRWDT
    BTFSC PORT_B,RXDLINE
    GOTO TXD_DATA
    BTFSC PORT_B,TXDLINE
    GOTO RXD_DATA
    BTFSC PORT_B,SEL
    GOTO START_BIT
    BSF ABORT,7

A90 CLRWDT
    CALL DELAY_DATA
    BTFSC PORT_B,SEL
    RETLW 0
    GOTO A90

TXD_DATA
    MOVLW 8           ;8 DATA BITS
    MOVWF COUNTR
    CALL DELAY1ST     ;1.5 BITS DELAY
    CLRF BUFFER       ;CLEAR BUFFER

NEXT_BIT
    BCF STATUS,0
    RRF BUFFER
    BTFSC PORT_B,RXDLINE ;8031
    BSF BUFFER,7
    CALL DELAY
    DECFSZ COUNTR,1
    GOTO NEXT_BIT

    MOVLW 0FFH
    XORWF BUFFER,0
    MOVWF DATABYTE    ;SAVE RECEIVED DATA
    BCF  BUFFER_2,7
    RETLW 0

RXD_DATA
    MOVLW 8           ;8 DATA BITS
    MOVWF COUNTR
    CALL DELAY1ST     ;1.5 BITS DELAY
    CLRF BUFFER       ;CLEAR BUFFER

NEXT_BITR
    BCF STATUS,0
    RRF BUFFER
    BTFSC PORT_B,TXDLINE ;PC
    BSF BUFFER,7
    CALL DELAY
    DECFSZ COUNTR,1
    GOTO NEXT_BITR

    MOVLW 0FFH
    XORWF BUFFER,0
    MOVWF DATABYTE    ;SAVE RECEIVED DATA
    BSF  BUFFER_2,7
    RETLW 0

INIT_DISPLAY
    CALL LDELAY

    MOVLW 033H
    CALL COMMAND
    MOVLW 032H
    CALL COMMAND
    MOVLW 028H
    CALL COMMAND
    MOVLW 6
    CALL COMMAND
    MOVLW 0EH
    CALL COMMAND
    MOVLW 1
    CALL COMMAND
    CALL LDELAY
    RETLW 0

LDELAY
      MOVLW B'00000011'
      OPTION
      CLRF RTCC
L_DELAY
      CLRWDT
      BTFSS RTCC,7
      GOTO L_DELAY
      RETLW 0

DELAY_DATA
      MOVLW DEBOUNCE
      MOVWF DLYCNT
REDB DECFSZ DLYCNT,1

      goto REDB
      CLRWDT
      RETLW 0
CLEAR
    MOVLW 080H
    CALL COMMAND
    MOVLW ' '
    MOVWF A_N
    CALL  WRITE

    MOVLW 082H    ;1ST LINE
    CALL COMMAND

    MOVLW 'A'
    CALL WRITE
    MOVLW 'r'
    CALL WRITE
    MOVLW 'm'
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE



    MOVLW 0A9H    ;2ND LINE
    CALL COMMAND

    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
     RETLW 0

SELECTINIT
    MOVLW 0A9H    ;2ND LINE
    CALL COMMAND
    MOVLW ' '
    CALL WRITE
    MOVLW 'S'
    CALL WRITE
    MOVLW 'e'
    CALL WRITE
    MOVLW 'l'
    CALL WRITE
    MOVLW 'e'
    CALL WRITE
    MOVLW 'c'
    CALL WRITE
    MOVLW 't'
    CALL WRITE
    MOVLW 07EH
    CALL WRITE

    MOVLW 080H    ;1ST LINE
    CALL COMMAND
    MOVLW 07FH
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    MOVLW ' '
    CALL WRITE
    RETLW 0


GO
    MOVLW 0
    TRIS PORT_A
    MOVLW B'10011001'
    TRIS PORT_B
                 ;RB0 SELECT
                 ;RB3 RXD LINE
                 ;RB4 TXD LINE
                 ;RB7 ENTER

    BSF PORT_B,REDLED
    BSF PORT_B,GREENLED
                        ;AMBER SYSTEM ON
    BCF PORT_B,RS
    BCF PORT_B,E
    MOVLW 0FH
    MOVWF PORT_A
    CALL INIT_DISPLAY
    RETLW 0

POSITION
    MOVLW 082H
    CALL COMMAND

    MOVLW ' '
    CALL WRITE
    MOVLW 'N'
    CALL WRITE
    MOVLW 'o'
    CALL WRITE
    MOVLW '.'
    CALL WRITE
    MOVF XODE,0
    CALL WRITE
    INCF XODE,1
    RETLW 0



;BAUD   EQU  .136 ;2400 .68(4800) .14(19200) .34(9600)   1 BIT
;BAUD1ST EQU .180 ;2400 .90(4800) .22(19200) .45(9600)     1.5 BITS
; baud    equ 5   (38k)    equ 2 (57.6k)
; baud1st equ .10 (38k)    equ 4 (57.6k)


DEBOUNCE EQU 0FFH
SEL       EQU 0      ;RB0   INPUT/INTERRUPT
ENTER     EQU 7      ;RB7   ENTER
E         EQU 1      ;RB1   LCD
RS        EQU 2      ;RB2   LCD
REDLED    EQU 5      ;RB5   XOFF
GREENLED  EQU 6      ;RB6   XON

RXDLINE   EQU 3      ;RB3
TXDLINE   EQU 4      ;RB4

INDEX     EQU 0
RTCC      EQU 1      ;RTCC
PC        EQU 2
STATUS    EQU 3      ;STATUS REGISTER
FSR       EQU 4
PORT_A    EQU 5      ;PORT A  LCD DATA BUS
PORT_B    EQU 6      ;PORT B  CONTROL/MONITOR


THIRTYTWO EQU 0BH    ;MODULUS 32 COUNTER
COUNTER   EQU 0CH    ;ADDRESS  COUNTER
A_N       EQU 0DH    ;ALPHANUMERIC COUNTER
ADDRESS   EQU 0EH    ;LCD ADDRESS
COUNTR    EQU 0FH
BUFFER    EQU 010H
DATABYTE  EQU 011H
DLYCNT    EQU 012H
ASCII     EQU 013H
LCDDATA   EQU 014H
CELL1     EQU 015H
CELL15    EQU 016H
XODE      EQU 017H
ABORT      EQU 018H
BUFFER_2   EQU 019H

    END
