


;        GRAPHICS DISPLAY

        LIST    p=16f876

RTCC      EQU 1      ;RTCC
PC        EQU 2
STATUS    EQU 3      ;STATUS REGISTER
TXD EQU 0
PCH EQU 0AH
PTION EQU 081H
INTCON EQU 0BH





ROWS EQU 020H
COUNTER EQU 021H
THIRTYTWO EQU 022H   ;MODULUS 32 COUNTER
BEAT EQU 023H
MIN EQU 024H
SCROLL EQU 025H
LEVEL EQU 026H
COUNTR  EQU 027H
DLYCNT EQU 028H
BUFFER EQU 029H
DLYCNT2 EQU 02AH
AOUNT  EQU 02CH
SAVE EQU 02DH






PORTA EQU 5
PORTB EQU 6

RESET EQU 2
CK EQU 3
CS2 EQU 4
CS1 EQU 5
A0 EQU 6
SERIAL EQU 7
CONTRAST EQU 0

        ORG 0
    GOTO ALPHA

        ORG 4
      BCF INTCON,7
      BCF INTCON,1
DIMMER
    CALL DIMSPEED
    INCF LEVEL,1
    MOVF LEVEL,0
    XORLW 09FH
    BTFSS STATUS,2
    GOTO JKL
    MOVLW 080H
    MOVWF LEVEL


JKL
       MOVF LEVEL,0
       CALL TRANSMIT

     BTFSS PORTB,0
     GOTO DIMMER
     BSF INTCON,7
       RETFIE


ALPHA
    CALL INIT

   
REPEAT
    	MOVLW 0A0H  ;COLUMN DIRETIONY
	CALL TRANSMIT
     CALL FIRST

	CALL QUARTER


    	MOVLW 0A1H  ;COLUMN DIRETIONY
	CALL TRANSMIT
    CALL FIRST
		CALL QUARTER
		GOTO REPEAT

FIRST
;........................................
     MOVLW 0B0H
    CALL TRANSMIT

   MOVLW 012H     ;13H    018 -   012  RHS
  CALL TRANSMIT
    ;CALL QUARTER
   MOVLW 0F6H     ; 4 low order column
  CALL TRANSMIT
   
 
   MOVLW 0
    MOVWF COUNTER

KLK CALL MS50
  MOVF COUNTER,0

   NOP
    MOVLW 2
	MOVWF PCH
    MOVF COUNTER,0
    CALL ONE
    XORLW 0FFH
    CALL TRANSMITDATA        ;                COUNTER
	MOVLW 0
	MOVWF PCH
    INCF COUNTER,1
    MOVF COUNTER,0
    XORLW .100
    BTFSS STATUS,2
    GOTO KLK


    MOVLW 0B1H
    CALL TRANSMIT

     MOVLW 012H     ;13H    018 -   012  RHS
    CALL TRANSMIT
    ;CALL QUARTER
    MOVLW 0F6H      ; 4
    CALL TRANSMIT
 


    MOVLW 0
    MOVWF COUNTER

KLKK CALL MS50
    MOVF COUNTER,0

	MOVLW 2
	MOVWF PCH
	MOVF COUNTER,0

    CALL TWO
    XORLW 0FFH
    CALL TRANSMITDATA        ;                COUNTER
	MOVLW   0
	MOVWF PCH
    INCF COUNTER,1
    MOVF COUNTER,0
    XORLW .100
    BTFSS STATUS,2
    GOTO KLKK

 



   MOVLW 0B2H
    CALL TRANSMIT

     MOVLW 012H     ;13H    018 -   012  RHS
    CALL TRANSMIT
  ;  CALL QUARTER
    MOVLW 0F6H      ; 4
    CALL TRANSMIT
   
 
    MOVLW 0
    MOVWF COUNTER

KLKP  CALL MS50
    MOVF COUNTER,0

	MOVLW 3
	MOVWF PCH
	MOVF COUNTER,0

    CALL THREE
    XORLW 0FFH
    CALL TRANSMITDATA        ;                COUNTER
	MOVLW 0
	MOVWF PCH
    INCF COUNTER,1
    MOVF COUNTER,0
    XORLW .100
    BTFSS STATUS,2
    GOTO KLKP


    MOVLW 0B3H
    CALL TRANSMIT

     MOVLW 012H     ;13H    018 -   012  RHS
    CALL TRANSMIT
  ;  CALL QUARTER
    MOVLW 0F6H      ; 4
    CALL TRANSMIT
 


    MOVLW 0
    MOVWF COUNTER

KLKKP CALL MS50
    MOVF COUNTER,0

    MOVLW 3
	MOVWF PCH
	MOVF COUNTER,0
   
    CALL FOUR
    XORLW 0FFH
    CALL TRANSMITDATA        ;                COUNTER
	MOVLW 0
	MOVWF PCH
    INCF COUNTER,1
    MOVF COUNTER,0
    XORLW .100
    BTFSS STATUS,2
    GOTO KLKKP

 





 MOVLW 0B4H
    CALL TRANSMIT

     MOVLW 012H     ;13H    018 -   012  RHS
    CALL TRANSMIT
   ; CALL QUARTER
    MOVLW 0F6H      ; 4
    CALL TRANSMIT
 


    MOVLW 0
    MOVWF COUNTER

AS   CALL MS50

    MOVF COUNTER,0

    MOVLW 4
	MOVWF PCH
	MOVF COUNTER,0
   
    CALL FIVE
    XORLW 0FFH
    CALL TRANSMITDATA        ;                COUNTER
    

    INCF COUNTER,1
    MOVF COUNTER,0
    XORLW .100
    BTFSS STATUS,2
    GOTO AS





 MOVLW 0B5H
   CALL TRANSMIT

     MOVLW 012H     ;13H    018 -   012  RHS
     CALL TRANSMIT
  ;  CALL QUARTER
    MOVLW 0F6H      ; 4
    CALL TRANSMIT
 


    MOVLW 0
    MOVWF COUNTER

XC  CALL MS50
    MOVF COUNTER,0

    MOVLW 4
	MOVWF PCH
	MOVF COUNTER,0
   
    CALL SIX
	    XORLW 0FFH
    CALL TRANSMITDATA  

    
      ;                COUNTER

    INCF COUNTER,1
    MOVF COUNTER,0
    XORLW .100
    BTFSS STATUS,2
    GOTO XC



 MOVLW 0B6H
   CALL TRANSMIT

     MOVLW 012H     ;13H    018 -   012  RHS
     CALL TRANSMIT
  ;  CALL QUARTER
    MOVLW 0F6H      ; 4
    CALL TRANSMIT
 


    MOVLW 0
    MOVWF COUNTER

CXC  CALL MS50
    MOVF COUNTER,0

    MOVLW 5
	MOVWF PCH
	MOVF COUNTER,0
   
    CALL SEVEN
	
    XORLW 0FFH
    CALL TRANSMITDATA  

    
      ;                COUNTER

    INCF COUNTER,1
    MOVF COUNTER,0
    XORLW .100
    BTFSS STATUS,2
    GOTO CXC




 MOVLW 0B7H
   CALL TRANSMIT

     MOVLW 012H     ;13H    018 -   012  RHS
     CALL TRANSMIT
  ;  CALL QUARTER
    MOVLW 0F6H      ; 4
    CALL TRANSMIT
 


    MOVLW 0
    MOVWF COUNTER

BCXC  CALL MS50
    MOVF COUNTER,0

    MOVLW 5
	MOVWF PCH
	MOVF COUNTER,0
   
    CALL EIGHT
	
    XORLW 0FFH
    CALL TRANSMITDATA  

    
      ;                COUNTER

    INCF COUNTER,1
    MOVF COUNTER,0
    XORLW .100
    BTFSS STATUS,2
    GOTO BCXC





    RETURN





MS50  RETURN
 



TRANSMIT
    BSF PORTB,CS1
    BCF PORTB,CS2
    NOP
    NOP
    NOP
    BCF PORTB,CS1
    BSF PORTB,CS2


    BCF PORTB,A0   ;COMMAND


    MOVWF BUFFER

    MOVLW 8
    MOVWF COUNTR

NEXT NOP
    RLF BUFFER,1
    BTFSC STATUS,0
    CALL BITH
    BTFSS STATUS,0
    CALL BITL
    DECFSZ COUNTR,1
    GOTO NEXT
    NOP

    BSF PORTB,A0   ;COMMAND
    RETLW 0

BITH

    BSF PORTB,SERIAL
    BCF PORTB,CK
    NOP
    BSF PORTB,CK
    NOP
    BCF PORTB,CK
    RETLW 0

BITL

    BCF PORTB,SERIAL
    BCF PORTB,CK
    NOP
    BSF PORTB,CK
    NOP
    BCF PORTB,CK
    RETLW 0


TRANSMITDATA
    BSF PORTB,CS1
    BCF PORTB,CS2
    NOP
    NOP
    NOP
    BCF PORTB,CS1
    BSF PORTB,CS2


    BSF PORTB,A0   ;DATA


    MOVWF BUFFER

    MOVLW 8
    MOVWF COUNTR

NEXX NOP
    RLF BUFFER,1
    BTFSC STATUS,0
    CALL BIXH
    BTFSS STATUS,0
    CALL BIXL
    DECFSZ COUNTR,1
    GOTO NEXX
    NOP

    BCF PORTB,A0
	CALL FLASH
    RETLW 0

BIXH

    BSF PORTB,SERIAL
    BCF PORTB,CK
    NOP
    BSF PORTB,CK
    NOP
    BCF PORTB,CK
    RETLW 0

BIXL

    BCF PORTB,SERIAL
    BCF PORTB,CK
    NOP
    BSF PORTB,CK
    NOP
    BCF PORTB,CK
    RETLW 0

FLASH
	MOVLW .25
	MOVWF COUNTR
ESD NOP
	DECFSZ COUNTR,1
	GOTO ESD
	RETURN

QUARTER

    MOVLW B'00000110';  PRESCALER 00000111 (/256)
    OPTION
    CLRF RTCC
    CLRWDT

    MOVLW .35 ;25
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

BHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP5
      CLRWDT
      GOTO BHORT

JMP5 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO BHORT
    RETLW 0

DIMSPEED

  MOVLW B'00000110';  PRESCALER 00000111 (/256)
    OPTION
    CLRF RTCC
    CLRWDT

    MOVLW 5 ;25
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

QBHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP5Q
      CLRWDT
      GOTO QBHORT

JMP5Q CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO QBHORT
    RETLW 0







INIT
     CALL MS50

    MOVLW B'00000001'
    TRIS  PORTB

     MOVLW 0
     TRIS PORTA

     BCF PORTB,RESET
     NOP
     CALL MS50
  
     BSF PORTB,RESET

     MOVLW 093H      ;088H  085H 08FH   INITIAL CONTRAST LEVEL
    MOVWF LEVEL      ;MAX = 09FH

     MOVLW 0E2H   ;INTERNAL RESET
    CALL TRANSMIT


    MOVLW 086H   ;.............................
   ; MOVF LEVEL,0

    CALL TRANSMIT ;08F CONTRAST MID  9F HIGH

    MOVLW 025H
    CALL TRANSMIT  ;DC POWER ON

    CALL MS50

    MOVLW 0EDH
    CALL TRANSMIT  ;POWERON COMPLETE


     MOVLW 0AFH
     CALL TRANSMIT

    MOVLW 0CCH
    CALL TRANSMIT ;COM/SEG

   MOVLW 0A7H     ;a7 reversed..................................................
  CALL TRANSMIT
   BSF INTCON,7
   BSF INTCON,4
 
   RETURN





 
  

  ORG 0200H

ONE
   
	ADDWF PC

    DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0xBF
	DT 0x61,0xC1,0x87,0xFF,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x7F
	DT 0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x80
	DT 0x40,0xC0,0x80,0x80,0x80,0xC0,0x40,0x40,0x40,0x40
	DT 0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x40,0x40,0x40
	DT 0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x80,0x80
	DT 0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	DT 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
   
TWO
	ADDWF PC

    DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x7F,0x00,0xE3,0xE3
	DT 0xFF,0xFF,0xF7,0x00,0x00,0xFC,0xFF,0xFF,0xFF,0xFD
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFB,0xFB,0xFF,0xF3,0xF8
	DT 0xF8,0xFC,0xFC,0x7E,0x1F,0x1F,0x8F,0x07,0x03,0x83
	DT 0x89,0xF4,0xF4,0xF4,0xFC,0x9E,0xFA,0xFB,0xF9,0x01
	DT 0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x02,0x02
	DT 0x02,0x02,0x02,0x04,0x04,0x00,0x00,0x00,0x00,0x00
	DT 0x00,0x00,0x01,0x03,0x03,0x06,0x04,0x04,0x0C,0x78
	DT 0xF0,0x80,0x00,0x00,0x00,0x60,0x60,0x80,0xFC,0x00


   ORG 0300H


 
THREE
    ADDWF PC

    DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0x1F,0xF0,0xFE,0x8F,0x8F
	DT 0x80,0x80,0xC1,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x7F
	DT 0xCF,0xF3,0xF9,0xFE,0xFB,0xFB,0xFC,0xFF,0xFF,0xFF
	DT 0xFF,0xF7,0xFF,0xFF,0x9F,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFD,0xFE,0xFE,0xFE,0xFA,0xF2,0xF0,0xF0,0xF0,0xE0
	DT 0xE0,0xE0,0xA0,0x60,0x00,0x00,0x00,0x00,0x00,0x00
	DT 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	DT 0x00,0x83,0x83,0x8E,0xBC,0xF0,0xF0,0xFF,0xFF,0xBF
   
FOUR
	ADDWF PC


    DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0x3F,0x78,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x0F,0xF8
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x7F,0xFD,0xFF,0x3F
	DT 0x3F,0xBF,0x7B,0x3A,0xF0,0x30,0x38,0x30,0x70,0x70
	DT 0x70,0x40,0x40,0x04,0x80,0x40,0xC0,0xC0,0x20,0x00
	DT 0x00,0x07,0x7D,0xFF,0xF3,0xC3,0xC3,0xCB,0xCF,0xF3
	

    ORG 0400H
FIVE
	ADDWF PC

    DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0x3F,0x01,0x00,0x00,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xEF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0x7F,0xFF,0x3F,0xEF,0xCF,0xCF,0xCF,0xCF,0x80,0x3F
	DT 0xFF,0x9F,0x81,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0x3F,0x0F,0x07,0x01,0xE1,0xF0,0xF8
	DT 0xF8,0xFE,0xFE,0x7E,0xFE,0xFE,0xF8,0xF1,0xC1,0xC1
	DT 0x01,0x00,0x06,0xC0,0xDF,0xD7,0xF1,0xF1,0xBE,0xF0
	DT 0xF0,0xF0,0x70,0x3F,0xFF,0xFF,0xFF,0xFF,0x7E,0x00


SIX
	ADDWF PC


    DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFC,0x00,0x00,0x80,0x00,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFD,0xFB,0xFF,0xDF,0xDF,0xF9,0xFF,0xFE
	DT 0xFC,0xF9,0xFB,0xE7,0xC7,0xC7,0xDF,0xFF,0xBF,0xBF
	DT 0xBF,0xFF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF,0xBF
	DT 0xBF,0xA7,0xA7,0xBF,0xBE,0xA6,0x9C,0x9F,0x9F,0x9F
	DT 0x9F,0x9F,0x1F,0x9E,0x9E,0x9F,0x1F,0x1F,0x1F,0x1F
	DT 0x1E,0x3E,0x1F,0x1F,0x9F,0x87,0x87,0x87,0xC3,0xC7
	DT 0x41,0x65,0x62,0x3B,0x3B,0x1D,0x1D,0x06,0x03,0x00
	
      ORG 0500H
SEVEN

	ADDWF PC

    DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0x7F,0x80,0xF8,0x8C,0xF6,0xFF,0xFF,0xFF
	DT 0x7F,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xEF,0x6F,0x6F,0x7F,0xFF,0xFF,0xF9
	DT 0xFD,0x89,0x81,0x81,0x01,0x01,0x01,0x01,0x01,0x01
	DT 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x00
	DT 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	DT 0x00,0x00,0x00,0x60,0x10,0x10,0x00,0x00,0x00,0x00
	DT 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
EIGHT
	

	ADDWF PC

    DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF7,0xE1,0xE1
	DT 0xE1,0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 0xFF,0xFF,0xFF,0xF8,0xFA,0xFA,0xEC,0xE7,0xF7,0xFF
	DT 0xFF,0xF7,0xFA,0xFA,0xFE,0xDC,0xDC,0xFC,0xFC,0xFE
	DT 0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0x7A,0xFE,0xFE
	DT 0xFE,0x7E,0xFE,0xFE,0x7F,0xFF,0xFE,0xFF,0xFF,0xFF
	DT 0xF3,0xF8,0xFC,0xE0,0xE0,0xC0,0xC0,0xC0,0x60,0x20
	DT 0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00


     END



