
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  13. Feb 2008  18:05  *************

	processor  16F84
	radix  DEC

TMR0        EQU   0x01
PCL         EQU   0x02
TRISA       EQU   0x85
TRISB       EQU   0x86
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
OPTION_REG  EQU   0x81
RA0         EQU   0
RA1         EQU   1
RA2         EQU   2
RA3         EQU   3
RB3         EQU   3
p           EQU   0x0C
ddram       EQU   0x0F
x           EQU   0x10
y           EQU   0x11
command_in  EQU   0x12
data_in     EQU   0x10
bits_in     EQU   0x13
bitcnt      EQU   0x14
n           EQU   0x0F
i_2         EQU   0x10
ci          EQU   0x0F

	GOTO main

  ; FILE nokia16f84.c
			;
			; 
			; 
			;  
			;
			;#define _RES  RB3
			;#define _SCE RA3  
			;#define D_C RA2 
			;#define SCK RA1 
			;#define SDI RA0  
			; 
			; 
			;
			;  unsigned char const   PAT[ ] = {
			;
			; 
			;
			; 0Xff, 0Xff, 0Xff, 0Xff, 0Xff 
			;
			; 
			; 
			; };
			;
			;
			;
			;
			;
			;
			;void initlcd(void);					// Initializes the LCD.
			;void writecom(char);				// Writes a command.
			;void writedata(char);				// Writes data to DDRAM to illuminate the pixels.
			;void clockdata(char);				// Clocks in data into the PCD8544 controller.
			; 				// Erase the DDRAM contents.
			;void cursorxy(char,char);			// Position cursor to x,y.
			;void mainrom(void); 
			;void clearram(void); 
			;void delay10(char); 
			; 
			; 
			; 
			;
			;
			;
			;
			;
			;
			;void main(void)
			;{
_const1
	MOVWF ci
	CLRF  PCLATH
	MOVF  ci,W
	ANDLW .7
	ADDWF PCL,1
	RETLW .255
	RETLW .255
	RETLW .255
	RETLW .255
	RETLW .255
	RETLW .0
	RETLW .0
	RETLW .0
main
			;
			; unsigned char p;
			;  int roms;
			;	int i;
			;  
			;	TRISA = 0b00000;				// All SCK, SDI, D_C, _SCE and _RES are output pins
	BSF   0x03,RP0
	CLRF  TRISA
			;
			;  TRISB = 0B00000000;
	CLRF  TRISB
			;	 
			;   	initlcd(); 
	CALL  initlcd
			; /*   U   */
			;
			;
			;
			;
			;   p=PAT[0];
	MOVLW .0
	CALL  _const1
	MOVWF p
			; 	writedata  (p) ;
	MOVF  p,W
	CALL  writedata
			;
			;
			;  p=PAT[1];
	MOVLW .1
	CALL  _const1
	MOVWF p
			; 	writedata  (p) ;
	MOVF  p,W
	CALL  writedata
			;
			;
			;  p=PAT[2];
	MOVLW .2
	CALL  _const1
	MOVWF p
			; 	writedata  (p) ;
	MOVF  p,W
	CALL  writedata
			;
			;  p=PAT[3];
	MOVLW .3
	CALL  _const1
	MOVWF p
			; 	writedata  (p) ;
	MOVF  p,W
	CALL  writedata
			;
			;
			; 
			;  //   for (roms=0; roms<400; roms++) 
			;//{	writedata (0x81);
			;//}
			;
			; 
			;
			;
			;
			;
			;	//  demo 3310A test message.... Also a new year's greeting. :)
			; //	cursorxy(0,1);				// Next line.
			;
			;
			; 
			;
			; 	 
			;
			;  #asm
			;
			;
			;	nop
	NOP  
			;label:
			;  	nop
m001	NOP  
			; 	goto label
	GOTO  m001
			; #endasm
			;}
			; 
			; 
			;
			;
			;
			;
			;
			;
			;
			;
			;
			;
			;
			;
			;
			;void initlcd(void)
			;{
initlcd
			;	_RES = 1;		// Set _RES HIGH.
	BCF   0x03,RP0
	BSF   0x06,RB3
			;	_SCE = 1;		// Disable Chip.
	BSF   0x05,RA3
			;	_RES = 0;		// Reset the LCD.
	BCF   0x06,RB3
			;
			;   delay10(10);	// Wait 100ms. 
	MOVLW .10
	CALL  delay10
			; 
			;	_RES = 1;		// Awake LCD from RESET state.
	BCF   0x03,RP0
	BSF   0x06,RB3
			;
			;	writecom(0x21);		// Activate Chip and H=1.
	MOVLW .33
	CALL  writecom
			;	writecom(0xc8);		// c2 Set LCD Voltage to     about 7V.   vop
	MOVLW .200
	CALL  writecom
			;	writecom(0x13);		// Adjust voltage bias.
	MOVLW .19
	CALL  writecom
			;	writecom(0x20);		// Horizontal addressing and H=0.
	MOVLW .32
	CALL  writecom
			;	writecom(0x09);		// Activate all segments.
	MOVLW .9
	CALL  writecom
			;	 clearram();    	// Erase all pixel on the DDRAM.
	CALL  clearram
			;	writecom(0x08);		// Blank the Display.
	MOVLW .8
	CALL  writecom
			;
			;      delay10(10);	// Wait 100ms.
	MOVLW .10
	CALL  delay10
			;	writecom(0x0C);		// Display Normal.
	MOVLW .12
	CALL  writecom
			;     writecom(0x40);
	MOVLW .64
	CALL  writecom
			;	writecom(0x80);	
	MOVLW .128
	CALL  writecom
			;    
			;
			;	cursorxy(0,0);		// Cursor Home.
	CLRF  x
	MOVLW .0
	CALL  cursorxy
			;     delay10(10);	// Wait 100ms. 
	MOVLW .10
	CALL  delay10
			;     delay10(10);	// Wait 100ms.
	MOVLW .10
	CALL  delay10
			;	 clearram();
	CALL  clearram
			;     delay10(10);	// Wait 100ms.
	MOVLW .10
	GOTO  delay10
			;}
			;
			;void clearram(void)
			;{
clearram
			;	int ddram;
			;	cursorxy(0,0);											// Cursor Home.
	CLRF  x
	MOVLW .0
	CALL  cursorxy
			;	for (ddram=504;ddram>0;ddram--)	{writedata(0x00);}		// 6*84 = 504 DDRAM addresses.
	MOVLW .248
	MOVWF ddram
m002	BTFSC ddram,7
	GOTO  m003
	MOVF  ddram,1
	BTFSC 0x03,Zero_
	GOTO  m003
	MOVLW .0
	CALL  writedata
	DECF  ddram,1
	GOTO  m002
			;}
m003	RETURN
			;
			;
			;
			;void cursorxy(char x, char y)
			;{
cursorxy
	MOVWF y
			;	writecom(0x40|(y&0x07));	// Y axis
	MOVLW .7
	ANDWF y,W
	IORLW .64
	CALL  writecom
			;	writecom(0x80|(x&0x7f));	// X axis
	MOVLW .127
	ANDWF x,W
	IORLW .128
	GOTO  writecom
			;}
			;
			;
			;
			;
			;void writecom(char command_in)
			;{
writecom
	MOVWF command_in
			;	D_C = 0;				// Select Command register.
	BCF   0x03,RP0
	BCF   0x05,RA2
			;	_SCE = 0;				// Select Chip.
	BCF   0x05,RA3
			;	clockdata(command_in);	// Clock in command bits.
	MOVF  command_in,W
	CALL  clockdata
			;	_SCE = 1;				// Deselect Chip.	
	BCF   0x03,RP0
	BSF   0x05,RA3
			;}
	RETURN
			;
			;void writedata(char data_in)
			;{
writedata
	MOVWF data_in
			;	D_C = 1;				// Select Data register.
	BCF   0x03,RP0
	BSF   0x05,RA2
			;	_SCE = 0;				// Select Chip.
	BCF   0x05,RA3
			;	clockdata(data_in);		// Clock in data bits.
	MOVF  data_in,W
	CALL  clockdata
			;	_SCE = 1;				// Deselect Chip.	
	BCF   0x03,RP0
	BSF   0x05,RA3
			;}
	RETURN
			;
			;void clockdata(char bits_in)
			;{
clockdata
	MOVWF bits_in
			;	int bitcnt;
			;	for (bitcnt=8; bitcnt>0; bitcnt--)
	MOVLW .8
	MOVWF bitcnt
m004	BTFSC bitcnt,7
	GOTO  m007
	MOVF  bitcnt,1
	BTFSC 0x03,Zero_
	GOTO  m007
			;		{
			;			SCK = 0;								// Set Clock Idle level LOW.
	BCF   0x03,RP0
	BCF   0x05,RA1
			;			if ((bits_in&0x80)==0x80) {SDI=1;}		// PCD8544 clocks in the MSb first.
	BTFSS bits_in,7
	GOTO  m005
	BSF   0x05,RA0
			;			else {SDI=0;}
	GOTO  m006
m005	BCF   0x03,RP0
	BCF   0x05,RA0
			;			SCK = 1;								// Data is clocked on the rising edge of SCK.
m006	BCF   0x03,RP0
	BSF   0x05,RA1
			;			bits_in=bits_in<<1;						// Logical shift data by 1 bit left.
	BCF   0x03,Carry
	RLF   bits_in,1
			;		}
	DECF  bitcnt,1
	GOTO  m004
			;}
m007	RETURN
			; 
			;	
			; 
			; 
			; 
			;
			;void delay10( char n)
			;/*
			;  Delays a multiple of 10 milliseconds using the TMR0 timer
			;  Clock : 4 MHz   => period T = 0.25 microseconds
			;  1 IS = 1 Instruction Cycle = 1 microsecond
			;  error: 0.16 percent
			;*/
			;{
delay10
	MOVWF n
			;    char i;
			;   
			;    OPTION = 7;
	MOVLW .7
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;    do  {
			;       
			;        i = TMR0 + 39; /* 256 microsec * 39 = 10 ms */
m008	MOVLW .39
	BCF   0x03,RP0
	ADDWF TMR0,W
	MOVWF i_2
			;        while ( i != TMR0)
m009	MOVF  i_2,W
	BCF   0x03,RP0
	XORWF TMR0,W
	BTFSS 0x03,Zero_
			;            ;
	GOTO  m009
			;    } while ( --n > 0);
	DECFSZ n,1
	GOTO  m008
			;
			;
			;
			;}
	RETURN

	END


; *** KEY INFO ***

; 0x0029   39 word(s)  3 % : initlcd
; 0x0068    9 word(s)  0 % : writecom
; 0x0071    9 word(s)  0 % : writedata
; 0x007A   23 word(s)  2 % : clockdata
; 0x005F    9 word(s)  0 % : cursorxy
; 0x0050   15 word(s)  1 % : clearram
; 0x0091   16 word(s)  1 % : delay10
; 0x000E   27 word(s)  2 % : main
; 0x0001   13 word(s)  1 % : _const1

; RAM usage: 9 bytes (9 local), 59 bytes free
; Maximum call level: 5
; Total of 161 code words (15 %)
