 

#include <p18F252.h>

 

void main (void);
void InterruptHandlerHigh (void);
static unsigned long SecondsCount = 0;				// realtime clock seconds counter
union
{
  struct
  {
    unsigned Timeout:1; 
              //flag to indicate a TMR0 timeout
    unsigned None:7;
  } Bit;
  unsigned char Byte;
} Flags;
int count;

 
void
main ()


{
;
  
  Flags.Byte = 0;
  INTCON = 0x20;                //disable global and enable TMR0 interrupt
  INTCON2 = 0x84;               //TMR0 high priority
  RCONbits.IPEN = 1;            //enable priority levels
  TMR0H = 0;                    //clear timer
  TMR0L = 0;                    //clear timer
  T0CON = 0xC4;                 //set up timer0 - prescaler 1:2 0x80 16 bit    0xc0  8 bit
  INTCONbits.GIEH = 1;          //enable interrupts
  TRISB = 0; 
  TRISA = 0;
  count=0;
  while (1)
    {
 

                                // do nothing and wait for interrupt
 

     
  }

}


 
// High priority interrupt vector

#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh                          //jump to interrupt routine
  _endasm
}

 
// High priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerHigh


void InterruptHandlerHigh ()




{
	if  (INTCONbits.TMR0IF)	 
					                                   	// 32768hz timebase, TIMER1 has overflowed
	{
   INTCONbits.TMR0IF=0;
   Flags.Bit.Timeout=1;
  
   
		 
		SecondsCount++;							       	// one second has elapsed

		if ((SecondsCount/2)*2 == SecondsCount)
		{	PORTBbits.RB0 = 1;							// 1 PPS heartbeat LED on
            PORTBbits.RB7 = 0;  }
		else
    	{   PORTBbits.RB0 = 0;							// 1 PPS heartbeat LED off
            PORTBbits.RB7 = 1;  }
	}
}

 

  
