
  LIST    p=16f876

 

TMR0        EQU   0x01
TRISA       EQU   0X85
TRISB       EQU   0X86
TRISC       EQU   0X87
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
OPTION_REG  EQU   0x81

RA0         EQU   0    ;PORTC
RA1         EQU   1
RA2         EQU   2
RA3         EQU   3
RA4         EQU   4

roms        EQU   0x20
ddram       EQU   0x21
x           EQU   0x22
y           EQU   0x23
command_in  EQU   0x24
data_in     EQU   0x25
bits_in     EQU   0x26
bitcnt      EQU   0x27
n           EQU   0x28
i_2         EQU   0x29
 
counter2    EQU   0x2b



STATUS    EQU 3      ;STATUS REGISTER
BUFFER  EQU 02CH
COUNTR EQU 02DH
COUNTER EQU 02EH
DLYCNT EQU 02FH
THIRTYTWO EQU 030H
DATABYTE EQU 031H
BUZZ EQU 032H
TONE2 EQU 033H
COMMAS EQU 034H


AA EQU 040H
BB EQU 041H
CC EQU 042H
DD EQU 043H
EE EQU 044H
FF EQU 045H

GG EQU 046H
HH EQU 047H
II EQU 048H
JJ EQU 049H
TIME EQU 04AH

SAVE EQU 04BH

ROUND EQU 04CH
X1 EQU 04DH
X2 EQU 04EH

PC        EQU 2
PCH EQU 0AH
STATUS    EQU 3 


PORTA EQU 5
PORTB EQU 6
PORTC EQU 7

   ORG 0
   
  

  	 MOVLW 0 
     TRIS PORTA

   MOVLW 0 
     TRIS PORTB

   MOVLW 020H
     TRIS PORTC

 
  MOVLW B'00001111'
  OPTION
	 
  BSF PORTB,0

  MOVLW 0XFF
		 
  MOVWF PORTC

  MOVLW 0XFF
  MOVWF PORTB
   CALL  initlcd


   movlw 0xFF
   movwf counter2 
 
CVC  MOVLW 00H
   CALL  writedata
  DECFsZ counter2,1
   goto CVC
 
 

   movlw .249
   movwf counter2 
 
CVCA  MOVLW 00H
   CALL  writedata
  DECFsZ counter2,1
   goto CVCA
 



 


     MOVLW .30
     MOVWF TIME

AGAIN

 




  BCF PORTC,6   ;LED
 	 
BUG	 CLRWDT
     MOVLW 2
	MOVWF PCH
    CALL RECEIVE_DATA
	 MOVF DATABYTE,0   ;W CONTAINS BYTE
      XORLW 'Z'
       BTFSS STATUS,2
       GOTO BUG     ;NO
     


   MOVLW 2
	MOVWF PCH
	CALL RECEIVE_DATA
	MOVF DATABYTE,0
	XORLW 'D'
 	BTFSS STATUS,2
 	GOTO BUG



    MOVLW 2
	MOVWF PCH
	CALL RECEIVE_DATA
	MOVF DATABYTE,0
	XORLW 'A'  ;G
 	BTFSS STATUS,2
 	GOTO BUG



    MOVLW 2
	MOVWF PCH
	CALL RECEIVE_DATA
	MOVF DATABYTE,0
	XORLW ','  ;G
 	BTFSS STATUS,2
 	GOTO BUG



 


   BSF PORTC,6  ; LED ON
 
ZX   MOVLW 2
	MOVWF PCH
   CALL RECEIVE_DATA  ;  6 BYTES  TIME 
	MOVF DATABYTE,0
  
      MOVWF AA

   

   MOVLW 2
	MOVWF PCH
 CALL RECEIVE_DATA  ;  6 BYTES  TIME 
	MOVF DATABYTE,0
 
    MOVWF BB
  
    

   MOVLW 2
	MOVWF PCH
 CALL RECEIVE_DATA  ;  6 BYTES  TIME 
	MOVF DATABYTE,0

     MOVWF CC



   
  MOVLW 2
	MOVWF PCH
 CALL RECEIVE_DATA  ;  6 BYTES  TIME 
	MOVF DATABYTE,0


    MOVWF DD


     


    MOVLW 2
	MOVWF PCH
 CALL RECEIVE_DATA  ;  6 BYTES  TIME 
	MOVF DATABYTE,0

     MOVWF EE


   

    MOVLW 2
	MOVWF PCH
 CALL RECEIVE_DATA  ;  6 BYTES  TIME 
	MOVF DATABYTE,0

    MOVWF FF





  MOVLW 0
	MOVWF PCH

    
     


  MOVLW .144
    MOVWF X1


      MOVF BB,0                                                             ;DATA TIME HH MM SS
   ;  MOVLW 038H
     MOVWF SAVE 
     MOVF SAVE,0

    CALL CONVERT
  

 
  

  MOVLW .172
    MOVWF X1


   MOVF DD,0                                                             ;DATA TIME HH MM SS
   ;  MOVLW 036H
     MOVWF SAVE 
     MOVF SAVE,0

    CALL CONVERT
  

  MOVLW .186
    MOVWF X1


      MOVF EE,0                                                             ;DATA TIME HH MM SS
   ;  MOVLW 035H
     MOVWF SAVE 
     MOVF SAVE,0

    CALL CONVERT
  


  MOVLW .200
    MOVWF X1

      MOVF FF,0                                                             ;DATA TIME HH MM SS
    ; MOVLW 034H
     MOVWF SAVE 
     MOVF SAVE,0

    CALL CONVERT



     MOVLW .130
    MOVWF X1

      MOVF AA,0                                                             ;DATA TIME HH MM SS
    ; MOVLW 039H
     MOVWF SAVE 
     MOVF SAVE,0

    CALL CONVERT
  
    MOVLW .158
    MOVWF X1
  
                                        
      MOVF CC,0                                                             ;DATA TIME HH MM SS
    ;  MOVLW 031H
     MOVWF SAVE 
     MOVF SAVE,0

    CALL CONVERT



 
   ;VVV GOTO VVV




;...............................


   DECFSZ TIME,1
   GOTO AGAIN

  CLRWDT
 
 
     movlw 0x80
     call writecom     
     movlw 0x24 
     call writecom   

   MOVLW 0 
  MOVWF PORTA


   MOVLW 0 
  MOVWF PORTB


   MOVLW 0 
  MOVWF PORTC

   CLRWDT
   sleep
 
 
;.................................................










CONVERT
      MOVF X1,0
    ; movlw 0x82          ;80 -FF ACROSS (0-80) DOTS
      call writecom     
     movlw 0x43          ;DOWN 40-47 1 BYTE
    call writecom   

    
     

 
      XORLW '0'       
      BTFSS STATUS,2
      GOTO BRAVO
      MOVLW 0
      MOVWF COUNTER
      GOTO BOXES

BRAVO
      MOVF SAVE,0    
      XORLW '1'       
      BTFSS STATUS,2
      GOTO CHARLIE
      MOVLW 018H
      MOVWF COUNTER
      GOTO  BOXES




CHARLIE
      MOVF SAVE,0    
      XORLW '2'       
      BTFSS STATUS,2
      GOTO DELTA
      MOVLW 030H
      MOVWF COUNTER
      GOTO  BOXES



DELTA
      MOVF SAVE,0    
      XORLW '3'       
      BTFSS STATUS,2
      GOTO ECHO
      MOVLW 048H
      MOVWF COUNTER
      GOTO  BOXES




ECHO
      MOVF SAVE,0    
      XORLW '4'       
      BTFSS STATUS,2
      GOTO FOX
      MOVLW 060H
      MOVWF COUNTER
      GOTO  BOXES




FOX
      MOVF SAVE,0    
      XORLW '5'       
      BTFSS STATUS,2
      GOTO GOLF
      MOVLW 078H
      MOVWF COUNTER
      GOTO  BOXES





GOLF
      MOVF SAVE,0    
      XORLW '6'       
      BTFSS STATUS,2
      GOTO HOTEL
      MOVLW 090H
      MOVWF COUNTER
      GOTO  BOXES





HOTEL
      MOVF SAVE,0    
      XORLW '7'       
      BTFSS STATUS,2
      GOTO INDIA
      MOVLW 0A8H
      MOVWF COUNTER
      GOTO  BOXES




INDIA
      MOVF SAVE,0    
      XORLW '8'       
      BTFSS STATUS,2
      GOTO JULIET
      MOVLW 0C0H
      MOVWF COUNTER
      GOTO  BOXES




JULIET
      MOVF SAVE,0    
      XORLW '9'       
      BTFSS STATUS,2
      GOTO KILO
      MOVLW 0D8H
      MOVWF COUNTER
      GOTO  BOXES



KILO
       
 


BOXES




    MOVLW 0
    MOVWF ROUND

ab  
     

    MOVLW 2
	MOVWF PCH
   
    MOVF COUNTER,0
    CALL ZERO
    
     CALL  writedata
	MOVLW 0
	MOVWF PCH
    INCF COUNTER,1
    INCF ROUND,1
    MOVF ROUND,0
    XORLW .12
    BTFSS STATUS,2
    GOTO ab



      MOVF X1,0
      
    ;  movlw 0x82          ;80 -FF ACROSS (0-80) DOTS
     call writecom     
     movlw 0x44         ;DOWN 40-47 1 BYTE
      call writecom   

 

     MOVLW 0
    MOVWF ROUND
    
abC  
     

    MOVLW 2
	MOVWF PCH
   
    MOVF COUNTER,0
    CALL ZERO 
    
      CALL  writedata
	MOVLW 0
	MOVWF PCH
    INCF COUNTER,1
    INCF ROUND,1
    MOVF ROUND,0
    XORLW .12
    BTFSS STATUS,2
    GOTO abC

  RETURN





 




m004		 
            ;m004	NOP  
			;	goto label
	GOTO  m004
			 





initlcd
			;	_RES = 1;		// Set _RES HIGH.
	BCF   0x03,RP0
	BSF   0x07,RA4
			;	_SCE = 1;		// Disable Chip.
	BSF   0x07,RA3
			;	_RES = 0;		// Reset the LCD.
	BCF   0x07,RA4
			;


			 ;    delay10(10);	// Wait 100ms.


 	MOVLW .4
 	CALL  delay10
 			; 


			;	_RES = 1;		// Awake LCD from RESET state.
	BCF   0x03,RP0
	BSF   0x07,RA4
			;
			;	writecom(0x21);		// Activate Chip and H=1.
	MOVLW 0x21
	CALL  writecom
			;	writecom(0xc2);		// c2 Set LCD Voltage to     about 7V.   vop
	MOVLW 0XC8
	CALL  writecom
			;	writecom(0x13);		// Adjust voltage bias.
	MOVLW 0X13
	CALL  writecom
			;	writecom(0x20);		// Horizontal addressing and H=0.
	MOVLW 0X20
	CALL  writecom
			;	writecom(0x09);		// Activate all segments.
	MOVLW .9
	CALL  writecom
			;	 clearram();    	// Erase all pixel on the DDRAM.
 
    movlw .10
   call delay10;



	MOVLW .8
	CALL  writecom
			;	writecom(0x0C);		// Display Normal.
	MOVLW .12
	CALL  writecom
			;     
		 
	 	MOVLW 0X40
	CALL  writecom


	MOVLW 0X80
	CALL  writecom

   RETLW 0
			


 
			;
			;
			;void cursorxy(char x, char y)
			;{
cursorxy
	MOVWF y
			;	writecom(0x40|(y&0x07));	// Y axis
	MOVLW .7
	ANDWF y,W
	IORLW .64
	CALL  writecom
			;	writecom(0x80|(x&0x7f));	// X axis
	MOVLW .127
	ANDWF x,W
	IORLW .128
	call  writecom
   RETURN
		 
writecom
	MOVWF command_in
			;	D_C = 0;				// Select Command register.
	BCF   0x03,RP0
	BCF   0x07,RA2
			;	_SCE = 0;				// Select Chip.
	BCF   0x07,RA3
			;	clockdata(command_in);	// Clock in command bits.
	MOVF  command_in,W
	CALL  clockdata
			;	_SCE = 1;				// Deselect Chip.	
	BCF   0x03,RP0
	BSF   0x07,RA3
			;}
	RETURN
		 
writedata
	MOVWF data_in
			;	D_C = 1;				// Select Data register.
	BCF   0x03,RP0
	BSF   0x07,RA2
			;	_SCE = 0;				// Select Chip.
	BCF   0x07,RA3
			;	clockdata(data_in);		// Clock in data bits.
	MOVF  data_in,W
	CALL  clockdata
			;	_SCE = 1;				// Deselect Chip.	
	BCF   0x03,RP0
	BSF   0x07,RA3
			;}
	RETURN
		 
clockdata
   clrwdt
	MOVWF bits_in
			;	int bitcnt;
			;	for (bitcnt=8; bitcnt>0; bitcnt--)
	MOVLW .8
	MOVWF bitcnt
m007	BTFSC bitcnt,7
	GOTO  m010
	MOVF  bitcnt,1
	BTFSC 0x03,Zero_
	GOTO  m010
			;		{
			;			SCK = 0;								// Set Clock Idle level LOW.
	BCF   0x03,RP0
	BCF   0x07,RA1
			;			if ((bits_in&0x80)==0x80) {SDI=1;}		// PCD8544 clocks in the MSb first.
	BTFSS bits_in,7
	GOTO  m008
	BSF   0x07,RA0
			;			else {SDI=0;}
	GOTO  m009
m008	BCF   0x03,RP0
	BCF   0x07,RA0
			;			SCK = 1;								// Data is clocked on the rising edge of SCK.
m009	BCF   0x03,RP0
	BSF   0x07,RA1
			;			bits_in=bits_in<<1;						// Logical shift data by 1 bit left.
	BCF   0x03,Carry
	RLF   bits_in,1
			;		}
	DECF  bitcnt,1
	GOTO  m007
			;}
m010	RETURN





		 
delay10
	MOVWF n
		 
	MOVLW .7
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;    do  {
			;        clrwdt();  // only if watchdog enabled
m011	CLRWDT
			;        i = TMR0 + 39; /* 256 microsec * 39 = 10 ms */
	MOVLW .40
	BCF   0x03,RP0
	ADDWF TMR0,W
	MOVWF i_2
			;        while ( i != TMR0)
m012  clrwdt
	MOVF  i_2,W
	BCF   0x03,RP0
	XORWF TMR0,W
	BTFSS 0x03,Zero_
			;            ;
	GOTO  m012
		 
	DECFSZ n,1
	GOTO  m011
		 
	RETURN





  ORG 0200H

ZERO
    ADDWF PC

;C:\Documents and Settings\RG4\Desktop\0.bmp (12 x 16)
	dt 	0xFF,0x01,0xF1,0xF9,0x1D,0x0D,0x0D,0x1D,0xF9,0xF1,0x01,0xFF
 
	dt 	0xFF,0x80,0x8F,0x9F,0xB8,0xB0,0xB0,0xB8,0x9F,0x8F,0x80,0xFF

 
 ;C:\Documents and Settings\RG4\Desktop\1.bmp (12 x 16)
	dt 	0xFF,0x01,0x01,0x61,0x31,0x19,0xFD,0xFD,0x01,0x01,0x01,0xFF

 
 
	dt 	0xFF,0x80,0x80,0x80,0x80,0x80,0xBF,0xBF,0x80,0x80,0x80,0xFF

 
;C:\Documents and Settings\RG4\Desktop\2.bmp (12 x 16)
	dt 	0xFF,0x01,0x31,0x39,0x1D,0x0D,0x0D,0x8D,0xF9,0x71,0x01,0xFF

 

	dt 	0xFF,0x80,0xB0,0xB8,0xBC,0xB6,0xB7,0xB3,0xB1,0xB0,0x80,0xFF

 
;C:\Documents and Settings\RG4\Desktop\3.bmp (12 x 16)
	dt 	0xFF,0x01,0x11,0x19,0x0D,0xCD,0xCD,0xCD,0xFD,0x39,0x01,0xFF

 

	dt 	0xFF,0x80,0x8C,0x9C,0xB8,0xB0,0xB0,0xB9,0x9F,0x8F,0x80,0xFF
 
;C:\Documents and Settings\RG4\Desktop\4.bmp (12 x 16)
	dt 	0xFF,0x01,0x01,0x01,0xC1,0xE1,0x39,0xFD,0xFD,0x01,0x01,0xFF

 


	dt 	0xFF,0x80,0x8E,0x8F,0x8D,0x8C,0x8C,0xBF,0xBF,0x8C,0x80,0xFF

 
;C:\Documents and Settings\RG4\Desktop\5.bmp (12 x 16)
	dt 	0xFF,0x01,0xE1,0xFD,0xFD,0xCD,0xCD,0xCD,0x8D,0x01,0x01,0xFF

 



	dt 	0xFF,0x80,0x8D,0x9D,0xB8,0xB0,0xB0,0xB9,0x9F,0x8F,0x80,0xFF

 
;C:\Documents and Settings\RG4\Desktop\6.bmp (12 x 16)
	dt 	0xFF,0x01,0xE1,0xF9,0x9D,0xCD,0xCD,0xCD,0x9D,0x19,0x01,0xFF
 

	dt 	0xFF,0x80,0x87,0x9F,0xB9,0xB0,0xB0,0xB1,0x9F,0x8F,0x80,0xFF

 
;C:\Documents and Settings\RG4\Desktop\7.bmp (12 x 16)
	dt 	0xFF,0x01,0x0D,0x0D,0x0D,0x8D,0xED,0x7D,0x1D,0x0D,0x01,0xFF
 
	dt 	0xFF,0x80,0x80,0x80,0xBC,0xBF,0x87,0x80,0x80,0x80,0x80,0xFF

 
;C:\Documents and Settings\RG4\Desktop\8.bmp (12 x 16)
	dt 	0xFF,0x01,0x71,0xF9,0x8D,0x8D,0x8D,0x8D,0xF9,0x71,0x01,0xFF

 
	dt 	0xFF,0x80,0x8E,0x9F,0xB1,0xB1,0xB1,0xB1,0x9F,0x8E,0x80,0xFF

 
;C:\Documents and Settings\RG4\Desktop\9.bmp (12 x 16)
	dt 	0xFF,0x01,0xF1,0xF9,0x8D,0x0D,0x0D,0x9D,0xF9,0xE1,0x01,0xFF

 

	dt 	0xFF,0x80,0x98,0xB9,0xB3,0xB3,0xB3,0xB9,0x9F,0x87,0x80,0xFF





 

   ORG 0300H





RECEIVE_DATA

START_BIT
    CLRWDT
     BTFSC PORTC,5
     GOTO START_BIT
    MOVLW 8           ;8 DATA BITS
    MOVWF COUNTR
    CALL DELAY1ST     ;1.5 BITS DELAY
    CLRF BUFFER       ;CLEAR BUFFER

NEXT
     BSF STATUS,0
    RRF BUFFER,1 
    BTFSS PORTC,5
    BCF BUFFER,7
     CALL DELAY
    DECFSZ COUNTR,1
    GOTO NEXT
	MOVF BUFFER,0
	MOVWF DATABYTE


    

   RETURN


 

DELAY 

      MOVLW .58
      MOVWF DLYCNT
REDO1STQ DECFSZ DLYCNT,1
      goto REDO1STQ
      CLRWDT
      RETURN
    


 

DELAY1ST

      MOVLW .89
      MOVWF DLYCNT
REDO1ST DECFSZ DLYCNT,1
      goto REDO1ST
      CLRWDT
      RETURN
    
  











 
   

    ORG 0400H
    
   
ALPHA
	ADDWF PC


	DT 	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07
    DT 0x0F,0x18,0x10,0x11,0x11,0x1F,0x0F,0x01,0x00,0x07,0x0F,0x18,0x10,0x10,0x18,0x0F,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
    DT 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
    DT 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
    DT 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	DT 	0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC
    DT 0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF





   
	END

 
